/*************************************************************************************
Jakub Borzdynski 2005
jotbeage@interia.pl
tel 501632185
---------------------
Rozwiazanie zadania 107 - Szkola Konstruktorow
-------------------------------------------------
Program do obslugi swiatla stop w samochodzie.
*************************************************************************************/
#include <at89x051.h>
#include "efekty.h"
//************************************************************************
void wait(unsigned char ile)  ;
void prezentuj(char nr_efektu) ;
char wskaznik_efektu = 0 ;
char zwloka = 5 ;
char wsk = 1 ; //do pokazywania na dane
//deklaracja tablicy z efektami. Mala uwaga: wiem, ze nakjlepsza bylaby tablica wielowymiarowa, 
//ale niestety nie udalo mi sie jej zadeklarowac...
const char efekty[1040] = { EFEKT1,EFEKT2,EFEKT3,EFEKT4,EFEKT5,EFEKT6,EFEKT7,EFEKT8,EFEKT9,EFEKT10,EFEKT11,EFEKT12,EFEKT13,EFEKT14,EFEKT15,EFEKT16} ;
//************************************************************************
//przerwanie
zewnetrzne() interrupt 0 using 2{
	//przerwanie od hamulca
	prezentuj(wskaznik_efektu) ;
	P1 = 0xFF ;
	P3 = 0xFF ;
	zwloka = 5 ; //resetuj czekanie (od nowa)
	return 0;
}
//************************************************************************
int main(){
	
	//ustawienie przerwan
	EA = 1 ; //wlacz przerwania globalne
	EX0 = 1 ; //przerwanie zewnetrzne
	
	while(1){ //petla glowna 
		//czekaj na powtorny sygnal
		for( ; zwloka>0 ; zwloka--){
			wait(255) ;
		}
		
		//przestaw sie na kolejny efekt
		wsk = 1 ; //ustaw na poczatku nastepnego efektu
		wskaznik_efektu++ ;
		if(wskaznik_efektu>15){wskaznik_efektu = 0 ; }
		
		//wejscie w stan idle-mode
		P1 = 0xFF ;
		P3 = 0xFF ;
		PCON = 0x01;
	}

}
//***************************************************
//generuje opoznienie 
void wait(unsigned char ile){
	unsigned char a=255;
	while(ile--){
		while(a--){ 
			;
		} 
	}
}
//***************************************************
//wyswietla efekt swiatla STOP
void prezentuj(char nr_efektu){
	//przygotowanie informacji o opoznieniu
	unsigned char opoznienie = efekty[nr_efektu * 65] ; //65 = 32 efekty * 2 porty + 1 bajt predkosci
	
	while(P3_2 == 0){ //warunek generowania efektu
		P1 = efekty[nr_efektu * 65 + wsk] ;
		wsk++ ;
		P3 = efekty[nr_efektu * 65 + wsk] ;
		wsk++ ;
		
		wait(opoznienie) ;
		
		//badanie konca tablicy
		if(efekty[nr_efektu * 65 + wsk]==0 && efekty[nr_efektu * 65 + wsk+1]==0){
			//koniec tablicy
			wsk = 1 ;
		}
	}
}
